﻿Imports System.Net
Imports System.Net.Sockets

Public Class Main

    ' Number of quries sent
    Private NbSent As Integer = 0

    ' Initialization
    Private Sub Main_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        ' Get local IPv4 addresses
        cbAddresses.Items.Clear()
        Dim ihe As IPHostEntry = Dns.GetHostEntry(Dns.GetHostName())
        Dim i As Integer
        For i = 0 To ihe.AddressList.Length - 1
            If ihe.AddressList(i).ToString.Split("."c).Length = 4 Then
                cbAddresses.Items.Add(ihe.AddressList(i))
            End If
        Next

        ' By default, select the first one
        cbAddresses.SelectedIndex = 0

        ' Send one query now
        SendDoubleQuery()

    End Sub

    ' Send general query IGMP v2 packet
    Private Sub GeneralQuery(ByVal LocalIPAddress As String)

        ' Packet declaration : IGMPv2
        Dim IgmpPacket(7) As Byte
        IgmpPacket(0) = &H11 ' Membership Query Igmp v2
        IgmpPacket(1) = 100 ' Timeout = 100 secondes

        ' Checksum of IGMP packet (static as the content doesn't change)
        IgmpPacket(2) = &HEE ' Checksum Hi
        IgmpPacket(3) = &H9B ' Checksum Lo

        ' Group address = 0.0.0.0 = General Query (all the IGMP groups)
        IgmpPacket(4) = 0 ' Destination multicast A
        IgmpPacket(5) = 0 ' Destination multicast B
        IgmpPacket(6) = 0 ' Destination multicast C
        IgmpPacket(7) = 0 ' Destination multicast D

        ' General query address = 224.0.0.1 =  All hosts
        Dim IgmpAddress As IPAddress = IPAddress.Parse("224.0.0.1")
        Dim IgmpDestination As IPEndPoint = New IPEndPoint(IgmpAddress, 0)
        Dim LocalAny As IPEndPoint = New IPEndPoint(IPAddress.Parse(LocalIPAddress), 0)
        Dim IgmpSocket As New Socket(IgmpAddress.AddressFamily, SocketType.Raw, ProtocolType.Igmp)

        ' Send
        IgmpSocket.Bind(LocalAny)
        IgmpSocket.SendTo(IgmpPacket, IgmpDestination)

        ' Information
        NbSent += 1
        lNbSent.Text = "Packets sent: " + NbSent.ToString
        lLastSent.Text = "Last packet sent: " + DateTime.Now.ToString("HH:mm:ss")

    End Sub

    ' Send two packets using select local IP address
    Private Sub SendDoubleQuery()
        Dim OriginIpAddress As String = cbAddresses.Items(cbAddresses.SelectedIndex).ToString.Trim()
        GeneralQuery(OriginIpAddress)
        GeneralQuery(OriginIpAddress)
    End Sub

    'Send now! button
    Private Sub bSendNow_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bSendNow.Click
        SendDoubleQuery()
    End Sub

    ' Query timer
    Private Sub QueryTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles QueryTimer.Tick
        SendDoubleQuery()
    End Sub

End Class
